package at.ac.uibk.gitsearch.service;

import static at.ac.uibk.gitsearch.web.rest.AccountResourceIT.TEST_USER_LOGIN;

import java.io.IOException;
import java.io.InputStream;

import org.gitlab4j.api.GitLabApiException;
import org.junit.Assert;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.security.test.context.support.WithMockUser;

import at.ac.uibk.gitsearch.GitsearchApp;

@SpringBootTest(classes = GitsearchApp.class)
@WithMockUser(value = TEST_USER_LOGIN, authorities = "sharing")
public class GitLabServiceIT {
	
	@Autowired
	GitlabService gitlabService;
	final String publicGitLabProjectId = "3";
	
	@Test
	public void testGitLabAccess( ) {
		Assert.assertTrue(gitlabService.repositoryExists(publicGitLabProjectId));
		Assert.assertFalse(gitlabService.repositoryExists("XXXX--keineId--XXX"));
	}

	@Test
	public void testGitLabDownload( ) throws GitLabApiException, IOException {
		final InputStream repositoryZip = gitlabService.getRepositoryZip(publicGitLabProjectId);
		// schwacher Test :-(
		Assert.assertNotNull(repositoryZip);
	}

}
